<!-- forms\user_framework\search_results.jsp -->
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>

<html>
<head>

	<style type="text/css">
<!--

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=styles/report.css -->
	<!-- /WSLET -->
</change:wsletExpander>

.tableHeader
{
	color: black;
	background-color: #B2BBCF;
	font-weight: bold;	
	text-align: left;
	padding: 2px 4px 2px 4px;
	white-space: nowrap;
}

THEAD A
{
	color: #006;
	font-weight: bold;	
}

-->
	</style>
	
	<script type="text/javascript">
<!--

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=EventUtils.js -->
	<!-- /WSLET -->
</change:wsletExpander>

function initialize()
{
	if (parent && parent.subbuttonbar)
	{
		parent.subbuttonbar.location = "<change:urlCreator webResource='PTWEB'/>?ACTION_FLAG=tokenless_form&TEMPLATE_FLAG=SearchResultsButtonBar";
	}
	
	stubOutPerformSearchForm();
}

function crSort(attributeName)
{
	if (document.performSearch.crSortOrder.value == attributeName)
	{
		if (document.performSearch.crDirection.value == "descending")
		{
			document.performSearch.crDirection.value = "";
		}
		else
		{
			document.performSearch.crDirection.value = "descending";
		}
	}
	else
	{
		document.performSearch.crDirection.value = "";
	}
	
	//Update preference on search configuration dialog if present
	if ((parent.parent.parent.config)
	 && (parent.parent.parent.config.updateCrSortPreferences))
	{
		parent.parent.parent.config.updateCrSortPreferences(attributeName, document.performSearch.crDirection.value);
	}
	
	document.performSearch.lastSortType.value = "changeRequests";
	document.performSearch.crSortOrder.value = attributeName;
	
	document.performSearch.submit();
}

function taskSort(attributeName)
{
	if (document.performSearch.taskSortOrder.value == attributeName)
	{
		if (document.performSearch.taskDirection.value == "descending")
		{
			document.performSearch.taskDirection.value = "";
		}
		else
		{
			document.performSearch.taskDirection.value = "descending";
		}
	}
	else
	{
		document.performSearch.taskDirection.value = "";
	}
	
	//Update preference on search configuration dialog if present
	if ((parent.parent.parent.config)
		&& (parent.parent.parent.config.updateTaskSortPreferences))
	{
		parent.parent.parent.config.updateTaskSortPreferences(attributeName, document.performSearch.taskDirection.value);
	}
	
	document.performSearch.lastSortType.value = "tasks";
	document.performSearch.taskSortOrder.value = attributeName;
	document.performSearch.submit();
}

function stubOutPerformSearchForm()
{
	document.performSearch.searchString.value = <change:javaScriptEscape value="${param.searchString}"/>;
	document.performSearch.objectType.value = <change:javaScriptEscape value="${param.objectType}"/>;
	document.performSearch.databases.value = <change:javaScriptEscape value="${param.databases}"/>;
	document.performSearch.crSortOrder.value = <change:javaScriptEscape value="${param.crSortOrder}"/>;
	document.performSearch.crDirection.value = <change:javaScriptEscape value="${param.crDirection}"/>;
	document.performSearch.taskSortOrder.value = <change:javaScriptEscape value="${param.taskSortOrder}"/>;
	document.performSearch.taskDirection.value = <change:javaScriptEscape value="${param.taskDirection}"/>;
}

function displayStatus()
{
	document.loadStatus.submit();
}

-->
	</script>
</head>

<body onload="initialize()">

<%-- Get the length of the returned CR and task results --%>
<c:set value="${fn:length(searchResults.crSearchResultItems)}" var="crResultLength"/>
<c:set value="${fn:length(searchResults.taskSearchResultItems)}" var="taskResultLength"/>

<%-- Make sure the search string is HTML encoded so it can be used by a resource string. --%>
<c:set var="searchString">
	<c:out value="${param.searchString}"/>
</c:set>

<%-- figure out which results string to use --%>
<table width="100%">
<tr>
	<td align="left" valign="top">
		<c:choose>
			<c:when test="${(crResultLength + taskResultLength) == 1}">
				<change:resource key="searchResultsOne">
					<change:param value="${searchString}"/>
				</change:resource>
			</c:when>
			<c:when test="${(crResultLength + taskResultLength) > 1}">
				<c:choose>
					<c:when test="${searchResults.searchWasLimited}">
						<change:resource key="maxSearchResultsMessage">
							<change:param value="${crResultLength + taskResultLength}"/>
							<change:param value="${searchResults.totalHitsFound}"/>
							<change:param value="${searchString}"/>
						</change:resource>
					</c:when>
					<c:otherwise>
						<change:resource key="searchResultsMoreThanOne">
							<change:param value="${crResultLength + taskResultLength}"/>
							<change:param value="${searchString}"/>
						</change:resource>
					</c:otherwise>
				</c:choose>
			</c:when>
		</c:choose>
	</td>
</tr>
<tr>
	<td	align="left" valign="top" style="color: red;">
		<change:searchInfo value="LAST_INDEX_TIME" var="lastIndexTime"/>
		
		<c:set var="lastIndexTimeNone">
			<change:resource key="never"></change:resource>
		</c:set>
		
		<c:if test="${lastIndexTime == lastIndexTimeNone}">
			<change:resource key="searchIncompleteInfo"/>
			<br />
			<a href="javascript:displayStatus();"><change:resource key="searchViewStatus"/></a>
		</c:if>
	</td>
</tr>
</table>

<%-- If there are CR results or the user searched for both CRs and tasks --%>
<c:if test="${crResultLength > 0 || param.objectType == 'both'}">
	<%-- If the user searched for both then we need a title and count of CRs and a link to the tasks --%>
	<c:if test="${param.objectType == 'both'}">
		<a name="changeRequests"/>
		<table width="100%" cellspacing="0" cellpadding="2">
		<tr>
			<td align="left">
				<b>
					<change:resource key="Problem_Identifier_Plural"/>
				</b>
				&nbsp;(${crResultLength})
			</td>
			<td align="right">
				<a href="#tasks">
					<change:resource key="goToX">
						<change:param>
							<change:resource key="lbl00032"/>
						</change:param>
					</change:resource>
				</a>
			</td>
		</tr>
		</table>
	</c:if>
	<table width="100%" cellspacing="0" cellpadding="2">
	<%-- Create the table header using all of the CR display attributes --%>
	<thead>
		<c:if test="${param.crDirection == ''}" var="crAscending"/>
		<tr class="tableHeader">
			<c:set var="attributes" value="${searchResults.crDisplayAttributes}"/>
			<c:forEach var="attribute" items="${attributes}">
				<td>
					<a href="javascript:crSort('${attribute}')">
						<change:attributeInformation attributeName="${attribute}" requestType="ALIAS"/>
					</a>
					
					<c:choose>
						<c:when test="${param.crSortOrder == attribute}">
							<c:choose>
								<c:when test="${crAscending}">
									<img src="<change:urlCreator webResource="PTIMAGES"/>sort_arrow_down.gif">
								</c:when>
								<c:otherwise>
									<img src="<change:urlCreator webResource="PTIMAGES"/>sort_arrow_up.gif">
								</c:otherwise>
							</c:choose>
						</c:when>
						<c:otherwise>
							<img src="<change:urlCreator webResource="PTIMAGES"/>sort_arrow_invisible.gif">
						</c:otherwise>
					</c:choose>
				</td>
			</c:forEach>
				<%-- Add the extra rank column to the end. --%>
				<td>
					<a href="javascript:crSort('')">
						<change:resource key="rank"/>
					</a>
					
					<c:choose>
						<c:when test="${param.crSortOrder == ''}">
							<c:choose>
								<c:when test="${crAscending}">
									<img src="<change:urlCreator webResource="PTIMAGES"/>sort_arrow_down.gif">
								</c:when>
								<c:otherwise>
									<img src="<change:urlCreator webResource="PTIMAGES"/>sort_arrow_up.gif">
								</c:otherwise>
							</c:choose>
						</c:when>
						<c:otherwise>
								<img src="<change:urlCreator webResource="PTIMAGES"/>sort_arrow_invisible.gif">
						</c:otherwise>
					</c:choose>
				</td>
		</tr>
	</thead>
	<tbody>
		<c:choose>
			<c:when test="${crResultLength == 0}">
				<tr>
					<%-- Get the length of the number of attributes for the column span --%>
					<c:set value="${fn:length(searchResults.crDisplayAttributes)}" var="crHeaderLength"/>
					<td align="center" colspan="${crHeaderLength + 1}">
						<b><change:resource key="java0004"/></b>
					</td>
				</tr>
			</c:when>
			<c:otherwise>
				<c:forEach var="searchResultsItem" items="${searchResults.crSearchResultItems}" varStatus="status">
					<tr>
						<c:forEach var="attribute" items="${searchResultsItem.attributes}">
						<td bgcolor="<c:if test="${((status.index + 1)% 2) == 0}">#DDDDDD</c:if>">
							<%-- Display the attribute --%>
							<c:choose>
								<c:when test="${attribute.name == 'problem_number'}">
									<c:set var="mouseOver">
										<c:choose>
											<c:when test="${fn:length(searchResultsItem.modifiableIn) == 0}">
												<change:resource key="searchResultsMouseOverSimple">
													<change:param value="${searchResultsItem.databaseAlias}"/>
												</change:resource>
											</c:when>
											<c:otherwise>
												<change:resource key="searchResultsMouseOver">
													<change:param value="${searchResultsItem.databaseAlias}"/>
													<change:param>
														<change:attributeInformation attributeName="modifiable_in" requestType="ALIAS"/>
													</change:param>
													<change:param value="${searchResultsItem.modifiableIn}"/>
												</change:resource>
											</c:otherwise>
										</c:choose>
								 	</c:set>
								 	<change:linkCreator text="${attribute.value}" type="CR_SHOW" cvid="${status.index + 1}" database="${searchResultsItem.database}" mouseOver="${mouseOver}"/>
		  						</c:when>
		  						<c:when test="${attribute.name == 'score'}">
		  							<c:choose>
		  								<c:when test="${attribute.value > .9}">
		  									<img src="<change:urlCreator webResource="PTIMAGES"/>rank4.gif">
		  								</c:when>
		  								<c:when test="${attribute.value > .7}">
		  									<img src="<change:urlCreator webResource="PTIMAGES"/>rank3.gif">
		  								</c:when>
		  								<c:when test="${attribute.value > .4}">
		  									<img src="<change:urlCreator webResource="PTIMAGES"/>rank2.gif">
		  								</c:when>
		  								<c:otherwise>
		  									<img src="<change:urlCreator webResource="PTIMAGES"/>rank1.gif">
		  								</c:otherwise>
		  							</c:choose>
		  						</c:when>
								<c:otherwise>
									<change:attributeFormat name="${attribute.name}" value="${attribute.value}" 
										dateFormat="REPORT" escape="true"/>									
								 </c:otherwise>
							</c:choose>
						</td>
						</c:forEach>
					</tr>
				</c:forEach>
			</c:otherwise>
		</c:choose>
	</tbody>
	</table>
</c:if>

<%-- If there are task results or the user searched for both CRs and tasks --%>
<c:if test="${taskResultLength > 0 || param.objectType == 'both'}">
	<%-- If the user searched for both then we need a title and count of tasks and a link to the CRs --%>
	<c:if test="${param.objectType == 'both'}">
		<br />
		<br />
		<a name="tasks"/>
		<table width="100%" cellspacing="0" cellpadding="2">
		<tr>
			<td align="left">
				<b>
					<change:resource key="lbl00032"/>
				</b>
				&nbsp;(${taskResultLength})
			</td>
			<td align="right">
				<a href="#changeRequests">
					<change:resource key="goToX">
						<change:param>
							<change:resource key="Problem_Identifier_Plural"/>
						</change:param>
					</change:resource>
				</a>
			</td>
		</tr>
		</table>
		<%-- 
			 If the user last sorted on tasks then we want to jump to the task section since 
			 searching actually re runs the whole search and just sorts differently. 
		--%>
		<c:if test="${param.lastSortType == 'tasks'}">		
			<script type="text/javascript">
			<!--
				EventUtils.addEvent(window, "load", viewTasks);
				
				function viewTasks()
				{
					document.location = "#tasks";
				}
			-->
			</script>
		</c:if>
	</c:if>
	
	<table width="100%" cellspacing="0" cellpadding="2">
	<%-- Create the table header using all of the task display attributes --%>
	<thead>
		<c:if test="${param.taskDirection == ''}" var="taskAscending"/>
		<tr class="tableHeader">
			<c:set var="attributes" value="${searchResults.taskDisplayAttributes}"/>
			<c:forEach var="attribute" items="${attributes}">
				<td>
					<a href="javascript:taskSort('${attribute}')">
						<change:attributeInformation attributeName="${attribute}" requestType="ALIAS"/>
					</a>
					
					<c:choose>
						<c:when test="${param.taskSortOrder == attribute}">
							<c:choose>
								<c:when test="${taskAscending}">
									<img src="<change:urlCreator webResource="PTIMAGES"/>sort_arrow_down.gif">
								</c:when>
								<c:otherwise>
	
									<img src="<change:urlCreator webResource="PTIMAGES"/>sort_arrow_up.gif">
								</c:otherwise>
							</c:choose>
						</c:when>
						<c:otherwise>
							<img src="<change:urlCreator webResource="PTIMAGES"/>sort_arrow_invisible.gif">
						</c:otherwise>
					</c:choose>
				</td>
			</c:forEach>
			<%-- Add the extra rank column to the end. --%>
				<td>
					<a href="javascript:taskSort('')">
						<change:resource key="rank"/>
					</a>
					
					<c:choose>
						<c:when test="${param.taskSortOrder == ''}">
							<c:choose>
								<c:when test="${taskAscending}">
									<img src="<change:urlCreator webResource="PTIMAGES"/>sort_arrow_down.gif">
								</c:when>
								<c:otherwise>
									<img src="<change:urlCreator webResource="PTIMAGES"/>sort_arrow_up.gif">
								</c:otherwise>
							</c:choose>
						</c:when>
						<c:otherwise>
							<img src="<change:urlCreator webResource="PTIMAGES"/>sort_arrow_invisible.gif">
						</c:otherwise>
					</c:choose>
				</td>
		</tr>
	</thead>
	<tbody>
		<c:choose>
			<c:when test="${taskResultLength == 0}">
				<tr>
					<%-- Get the length of the number of attributes for the column span --%>
					<c:set value="${fn:length(searchResults.taskDisplayAttributes)}" var="taskHeaderLength"/>
					<td align="center" colspan="${taskHeaderLength + 1}">
						<b><change:resource key="java0004"/></b>
					</td>
				</tr>
			</c:when>
			<c:otherwise>
				<c:forEach var="searchResultsItem" items="${searchResults.taskSearchResultItems}" varStatus="status">
					<tr>
						<c:forEach var="attribute" items="${searchResultsItem.attributes}">
						<td bgcolor="<c:if test="${((status.index + 1)% 2) == 0}">#DDDDDD</c:if>">
							<%-- Display the attribute --%>
							<c:choose>
								<c:when test="${attribute.name == 'task_number'}">
									<c:set var="mouseOver">
										<c:choose>
											<c:when test="${fn:length(searchResultsItem.modifiableIn) == 0}">
												<change:resource key="searchResultsMouseOverSimple">
													<change:param value="${searchResultsItem.databaseAlias}"/>
												</change:resource>
											</c:when>
											<c:otherwise>
												<change:resource key="searchResultsMouseOver">
													<change:param value="${searchResultsItem.databaseAlias}"/>
													<change:param>
														<change:attributeInformation attributeName="modifiable_in" requestType="ALIAS"/>
													</change:param>
													<change:param value="${searchResultsItem.modifiableIn}"/>
												</change:resource>
											</c:otherwise>
										</c:choose>
								 	</c:set>
								 	<change:linkCreator text="${attribute.value}" type="TASK_SHOW" cvid="${status.index + 1}" database="${searchResultsItem.database}" fromDBPath="${searchResultsItem.fromDBPath}" mouseOver="${mouseOver}" showCmMenu="false"/>
		  						</c:when>
		  						<c:when test="${attribute.name == 'score'}">
		  							<c:choose>
		  								<c:when test="${attribute.value > .9}">
		  									<img src="<change:urlCreator webResource="PTIMAGES"/>rank4.gif">
		  								</c:when>
		  								<c:when test="${attribute.value > .7}">
		  									<img src="<change:urlCreator webResource="PTIMAGES"/>rank3.gif">
		  								</c:when>
		  								<c:when test="${attribute.value > .4}">
		  									<img src="<change:urlCreator webResource="PTIMAGES"/>rank2.gif">
		  								</c:when>
		  								<c:otherwise>
		  									<img src="<change:urlCreator webResource="PTIMAGES"/>rank1.gif">
		  								</c:otherwise>
		  							</c:choose>
		  						</c:when>
								<c:otherwise>
							 		<change:attributeFormat name="${attribute.name}" value="${attribute.value}" 
										dateFormat="REPORT" escape="true"/>	
								</c:otherwise>
							</c:choose>
						</td>
						</c:forEach>
					</tr>
				</c:forEach>
			</c:otherwise>
		</c:choose>
	</tbody>
	</table>
</c:if>

<form name="performSearch" action="<change:urlCreator webResource='BASEURL'/>/performSearch.do" class="hiddenForm" method="POST" target="_self">
	<input name="token" type="hidden" value="${user.token}">
	<input name="searchString" type="hidden">
	<input name="objectType" type="hidden">
	<input name="databases" type="hidden">
	<input name="crSortOrder" type="hidden">
	<input name="crDirection" type="hidden">
	<input name="taskSortOrder" type="hidden">
	<input name="taskDirection" type="hidden">
	<input name="lastSortType" type="hidden">
</form>

<form name="loadStatus" action="<change:urlCreator webResource='BASEURL'/>/formLoader.do" class="hiddenForm" method="POST" target="_self">
	<input name="token" type="hidden" value="${user.token}">
	<input name="formName" type="hidden" value="searchStatus">
</form>

</body>

</html>
