<!-- reports\task_framework\block_loop_object.jsp -->
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>

<c:if test="${not empty objectQueryResults.queryResultItems}">
	<c:set value="${fn:length(objectQueryResults.queryResultItems)}" var="length"/>
		
	<c:if test="${length != 0}">
		<table width="100%" CELLSPACING=0>
		<tr>
			<td width="5%" valign="center" BGCOLOR="lightgray">&nbsp;</td>
			<td width="95%" valign="center">
	</c:if>
</c:if>

<c:forEach var="queryResultsItem" items="${objectQueryResults.queryResultItems}">
	<table class="reportItem" cellspacing="0" cellpadding="5" border="1">
	
		<c:set var="reportAttributes" value="${objectQueryResults.reportAttributes}"/>
		<c:set var="isRowOpen" value="false"/>
					
		<c:forEach var="attribute" items="${queryResultsItem.attributes}" varStatus="status">
		
			<%-- 
				Since JSTL cannot call function, first set the requested attribute then later
				we can call isRequestedAttribute on the queryResult object and it will use the
				name that was just set.
			--%>
			<c:set target="${objectQueryResults}" property="requestedAttributeName" value="${attribute.name}"/>
			
			<c:choose>
				<c:when test="${!objectQueryResults.requestedAttribute}">
					<%-- do nothing when the user did not want this attribute --%>
				</c:when>
				<c:when test="${attribute.isSpanning}">
					<tr>
						<td valign="center">
							<b>
								<c:choose>
									<c:when test="${attribute.label == ''}">
										&nbsp;
									</c:when>
									<c:otherwise>
										<c:out value="${attribute.label}"/>
									</c:otherwise>
								</c:choose>
							</b>
						</td>
						<td colspan="3" valign="center">
							<c:choose>
								<c:when test="${attribute.name == 'displayname'}">
								 	<c:set var="mouseOver">
										<c:choose>
											<c:when test="${fn:length(queryResultsItem.modifiableIn) == 0}">
												<change:resource key="searchResultsMouseOverSimple">
													<change:param value="${queryResultsItem.fromDB}"/>
												</change:resource>
											</c:when>
											<c:otherwise>
												<change:resource key="ObjectHyperLinkMouseOver">
													<change:param value="${queryResultsItem.fromDB}"/>
													<change:param>
														<change:attributeInformation attributeName="modifiable_in" requestType="ALIAS"/>
													</change:param>
													<change:param value="${queryResultsItem.modifiableIn}"/>
												</change:resource>
											</c:otherwise>
										</c:choose>
								 	</c:set>
									<change:linkCreator text="${attribute.value}" type="OBJECT_SHOW" cvid="${attribute.cvid}" database="${user.database}" 
										fromDBPath="${queryResultsItem.database}" mouseOver="${mouseOver}" chosenReport="objectdetail"/>
								</c:when>
								
								<c:when test="${attribute.name == 'source'}">
								 	<c:set var="mouseOver">
								 		<change:resource key="alt00196"/>
								 	</c:set>
								 	<c:set var="download">
								 		<change:resource key="lbl00140"/>
								 	</c:set>
									<change:linkCreator text="${attribute.value}" type="SOURCE_DOWNLOAD" cvid="${attribute.cvid}" database="${user.database}" 
										fromDBPath="${queryResultsItem.database}" mouseOver="${mouseOver}" sourceText="${download}"/>
								</c:when>
								
								<c:otherwise>
								 	<change:attributeFormat name="${attribute.name}" value="${attribute.value}" 
										dateFormat="REPORT" escape="true"/>
								</c:otherwise>
							</c:choose>
						</td>
					</tr>
				</c:when>
				<c:otherwise>
					<c:if test="${isRowOpen == false}">
						<tr>
						<c:set var="count" value="0"/>
						<c:set var="isRowOpen" value="true"/>
					</c:if>
						<td width="25%" valign="center">
							<b>
								<c:choose>
									<c:when test="${attribute.label == ''}">
										&nbsp;
									</c:when>
									<c:otherwise>
										<c:out value="${attribute.label}"/>
									</c:otherwise>
								</c:choose>
							</b>
						</td>
						<td width="25%" valign="center">
							<c:choose>
	  							<c:when test="${attribute.name == 'task_number'}">
								 	<c:set var="mouseOver">
										<c:choose>
											<c:when test="${fn:length(queryResultsItem.modifiableIn) == 0}">
												<change:resource key="searchResultsMouseOverSimple">
													<change:param value="${queryResultsItem.fromDB}"/>
												</change:resource>
											</c:when>
											<c:otherwise>
												<change:resource key="ObjectHyperLinkMouseOver">
													<change:param value="${queryResultsItem.fromDB}"/>
													<change:param>
														<change:attributeInformation attributeName="modifiable_in" requestType="ALIAS"/>
													</change:param>
													<change:param value="${queryResultsItem.modifiableIn}"/>
												</change:resource>
											</c:otherwise>
										</c:choose>
								 	</c:set>
									<change:linkCreator text="${attribute.value}" type="TASK_SHOW" cvid="${attribute.cvid}" database="${user.database}" 
										fromDBPath="${queryResultsItem.database}" mouseOver="${mouseOver}"/>
								</c:when>
								
								<c:when test="${attribute.name == 'source'}">
								 	<c:set var="mouseOver">
								 		<change:resource key="alt00196"/>
								 	</c:set>
								 	<c:set var="download">
								 		<change:resource key="lbl00140"/>
								 	</c:set>
									<change:linkCreator text="${attribute.value}" type="SOURCE_DOWNLOAD" cvid="${attribute.cvid}" database="${user.database}" 
										fromDBPath="${queryResultsItem.database}" mouseOver="${mouseOver}" sourceText="${download}"/>
								</c:when>
								
								<c:otherwise>
								 	<change:attributeFormat name="${attribute.name}" value="${attribute.value}"
								 		dateFormat="REPORT" escape="true"/>
								</c:otherwise>
							</c:choose>
						</td>
						<c:set var="count" value="${count + 1}"/>
						
					<c:if test="${((queryResultsItem.attributes[(status.index + 1)].isSpanning) || (count == 2) || (status.last))}">
						<c:choose>
							<c:when test="${count != 2}">
								<td>&nbsp;</td><td>&nbsp;</td>
							</c:when>
							<c:when test="${count != 2 && status.last}">
								<td>&nbsp;</td><td>&nbsp;</td>
							</c:when>
						</c:choose>
						</tr>
						<c:set var="isRowOpen" value="false"/>
					</c:if>
				</c:otherwise>
			</c:choose>
		</c:forEach>
	</table>
</c:forEach>

<c:if test="${not empty objectQueryResults}">
	<c:if test="${length != 0}">
			</td>
		</tr>
		</table>
	</c:if>
</c:if>
