<!-- reports\task_framework\block_loop_task.jsp -->
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>


<c:if test="${offlineDatabases != null}">
	<ul class="offline-list" style="display: none;">
		<c:forEach var="db" items="${offlineDatabases}">
			<li><c:out value="${db}"/></li>
		</c:forEach>
	</ul>
</c:if>

<c:if test="${not empty taskQueryResults.queryResultItems}">
	<c:set value="${fn:length(taskQueryResults.queryResultItems)}" var="length"/>
	
	<c:if test="${isSubTaskReport == 'true' && length != 0}">
		<table width="100%" CELLSPACING=0>
		<tr>
			<td width="5%" valign="center" BGCOLOR="gray">&nbsp;</td>
			<td width="95%" valign="center">
	</c:if>
</c:if>

<c:forEach var="queryResultsItem" items="${taskQueryResults.queryResultItems}">
	<table class="reportItem" cellspacing="0" cellpadding="5" border="1">
	
		<c:set var="reportAttributes" value="${taskQueryResults.reportAttributes}"/>
		<c:set var="isRowOpen" value="false"/>
					
		<c:forEach var="attribute" items="${queryResultsItem.attributes}" varStatus="status">
		
			<%-- 
				Since JSTL cannot call function, first set the requested attribute then later
				we can call isRequestedAttribute on the queryResult object and it will use the
				name that was just set.
			--%>
			<c:set target="${taskQueryResults}" property="requestedAttributeName" value="${attribute.name}"/>
			
			<c:choose>
				<c:when test="${!taskQueryResults.requestedAttribute}">
					<%-- do nothing when the user did not want this attribute --%>
				</c:when>
				<c:when test="${attribute.isSpanning}">
					<tr>
						<td valign="center">
							<b>
								<c:choose>
									<c:when test="${attribute.label == ''}">
										&nbsp;
									</c:when>
									<c:otherwise>
										<c:out value="${attribute.label}"/>
									</c:otherwise>
								</c:choose>
							</b>
						</td>
						<td colspan="3" valign="center">
							<c:choose>
								<c:when test="${attribute.name == 'task_number'}">
								 	<c:set var="mouseOver">
										<c:choose>
											<c:when test="${fn:length(queryResultsItem.modifiableIn) == 0}">
												<change:resource key="searchResultsMouseOverSimple">
													<change:param value="${queryResultsItem.fromDB}"/>
												</change:resource>
											</c:when>
											<c:otherwise>
												<change:resource key="ObjectHyperLinkMouseOver">
													<change:param value="${queryResultsItem.fromDB}"/>
													<change:param>
														<change:attributeInformation attributeName="modifiable_in" requestType="ALIAS"/>
													</change:param>
													<change:param value="${queryResultsItem.modifiableIn}"/>
												</change:resource>
											</c:otherwise>
										</c:choose>
								 	</c:set>
									<change:linkCreator text="${attribute.value}" type="TASK_SHOW" cvid="${attribute.cvid}" database="${user.database}" 
										fromDBPath="${queryResultsItem.database}" mouseOver="${mouseOver}"/>
								</c:when>
								 
								<c:otherwise>
								 	<change:attributeFormat name="${attribute.name}" value="${attribute.value}" 
								 		dateFormat="REPORT" escape="true"/>
								</c:otherwise>
							</c:choose>
						</td>
					</tr>
				</c:when>
				<c:otherwise>
					<c:if test="${isRowOpen == false}">
						<tr>
						<c:set var="count" value="0"/>
						<c:set var="isRowOpen" value="true"/>
					</c:if>
						<td width="25%" valign="center">
							<b>
								<c:choose>
									<c:when test="${attribute.label == ''}">
										&nbsp;
									</c:when>
									<c:otherwise>
										<c:out value="${attribute.label}"/>
									</c:otherwise>
								</c:choose>
							</b>
						</td>
						<td width="25%" valign="center">
							<c:choose>
	  							<c:when test="${attribute.name == 'task_number'}">
								 	<c:set var="mouseOver">
										<c:choose>
											<c:when test="${fn:length(queryResultsItem.modifiableIn) == 0}">
												<change:resource key="searchResultsMouseOverSimple">
													<change:param value="${queryResultsItem.fromDB}"/>
												</change:resource>
											</c:when>
											<c:otherwise>
												<change:resource key="ObjectHyperLinkMouseOver">
													<change:param value="${queryResultsItem.fromDB}"/>
													<change:param>
														<change:attributeInformation attributeName="modifiable_in" requestType="ALIAS"/>
													</change:param>
													<change:param value="${queryResultsItem.modifiableIn}"/>
												</change:resource>
											</c:otherwise>
										</c:choose>
								 	</c:set>
									<change:linkCreator text="${attribute.value}" type="TASK_SHOW" cvid="${attribute.cvid}"  database="${user.database}" 
										fromDBPath="${queryResultsItem.database}" mouseOver="${mouseOver}"/>
								</c:when>
								
								<c:otherwise>
								 	<change:attributeFormat name="${attribute.name}" value="${attribute.value}" 
								 		dateFormat="REPORT" escape="true"/>
								</c:otherwise>
							</c:choose>
						</td>
						<c:set var="count" value="${count + 1}"/>
						
					<c:if test="${((queryResultsItem.attributes[(status.index + 1)].isSpanning) || (count == 2) || (status.last))}">
						<c:choose>
							<c:when test="${count != 2}">
								<td>&nbsp;</td><td>&nbsp;</td>
							</c:when>
							<c:when test="${count != 2 && status.last}">
								<td>&nbsp;</td><td>&nbsp;</td>
							</c:when>
						</c:choose>
						</tr>
						<c:set var="isRowOpen" value="false"/>
					</c:if>
				</c:otherwise>
			</c:choose>
		</c:forEach>
	</table>
	<c:set var="objectQueryResults" value="${queryResultsItem.relatedResults}" scope="request"/>
	<jsp:include page="/WEB-INF/wsconfig/templates/pt/reports/task_framework/block_loop_object.jsp"/>
	<c:if test="${isSubTaskReport == 'false'}">
		<br>
	</c:if>
</c:forEach>

<c:if test="${not empty taskQueryResults}">
	<c:if test="${isSubTaskReport == 'true' && length != 0}">
			</td>
		</tr>
		</table>
	</c:if>
</c:if>
