<!-- reports\task_framework\task_column_ad_hoc_format.jsp -->
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ page import="com.telelogic.cs.report.QueryResultsItem" %>
<%@ page import="com.telelogic.cs.report.QueryResultsAttribute" %>

<%--
	c:if is used for a single if conditional test.
--%>
<c:if test="${queryResults.hasErrorMessage}">
	<%--
		If there is an error use c:set to set a variable in the request object called
		errorMessage and forward on to the error page.
	--%>
	<c:set value="${queryResults.errorMessage}" var="errorMessage" scope="request"/>
	<c:set var="infoIcon" scope="request">
		<c:if test="${queryResults.errorType == 3}">true</c:if>
	</c:set>
	<jsp:forward page="/WEB-INF/wsconfig/templates/pt/forms/block_message.jsp"/>
</c:if>

<c:set value="${fn:length(queryResults.queryResultItems)}" var="count"/>
<!-- count = ${count} -->

<table cellspacing="0" cellpadding="2" border="1">
<thead>
	<tr>
		<c:set var="reportAttributes" value="${queryResults.reportAttributes}"/>
		<c:forEach var="reportAttribute" items="${reportAttributes}">
			<td valign="center" bgcolor="lightgrey">
				<b>
					<change:attributeInformation attributeName="${reportAttribute}" requestType="ALIAS"/>
				</b>
			</td>
		</c:forEach>
	</tr>
</thead>
<tbody>
	<c:forEach var="queryResultsItem" items="${queryResults.queryResultItems}">
		<tr>
			<c:forEach var="attribute" items="${queryResultsItem.attributes}" varStatus="status">
				<%-- 
					Since JSTL cannot call function, first set the requested attribute then later
					we can call isRequestedAttribute on the queryResult object and it will use the
					name that was just set.
				--%>
				<c:set target="${queryResults}" property="requestedAttributeName" value="${attribute.name}"/>
				
				<c:choose>
					<c:when test="${!queryResults.requestedAttribute}">
						<%-- do nothing when the user did not want this attribute --%>
					</c:when>
					
					<c:otherwise>
						<td valign="center">
							<c:choose>
		  						<c:when test="${attribute.name == 'task_number'}">
								 	<c:set var="mouseOver">
										<c:choose>
											<c:when test="${fn:length(queryResultsItem.modifiableIn) == 0}">
												<change:resource key="searchResultsMouseOverSimple">
													<change:param value="${queryResultsItem.fromDB}"/>
												</change:resource>
											</c:when>
											<c:otherwise>
												<change:resource key="ObjectHyperLinkMouseOver">
													<change:param value="${queryResultsItem.fromDB}"/>
													<change:param>
														<change:attributeInformation attributeName="modifiable_in" requestType="ALIAS"/>
													</change:param>
													<change:param value="${queryResultsItem.modifiableIn}"/>
												</change:resource>
											</c:otherwise>
										</c:choose>
								 	</c:set>
									<change:linkCreator text="${attribute.value}" type="TASK_SHOW" cvid="${attribute.cvid}" database="${user.database}" 
										fromDBPath="${queryResultsItem.database}" mouseOver="${mouseOver}"/>
								</c:when>
								
								<c:otherwise>
								 	<change:attributeFormat name="${attribute.name}" value="${attribute.value}" 
								 		dateFormat="REPORT" escape="true"/>
								</c:otherwise>
							</c:choose>
						</td>
					</c:otherwise>
				</c:choose>
			</c:forEach>
		</tr>
	</c:forEach>
</tbody>
</table>
