<!-- reports\user_framework\block_loop_cr.jsp -->
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>

<%@ page import="com.telelogic.cs.report.QueryResultsItem" %>
<%@ page import="com.telelogic.cs.report.QueryResultsAttribute" %>

<c:forEach var="queryResultsItem" items="${crQueryResults.queryResultItems}">
	<table class="reportItem" cellspacing="0" cellpadding="5" border="1" width="97%">
	
		<c:set var="reportAttributes" value="${crQueryResults.reportAttributes}"/>
		<c:set var="isRowOpen" value="false"/>
					
		<c:forEach var="attribute" items="${queryResultsItem.attributes}" varStatus="status">
		
			<%-- 
				Since JSTL cannot call function, first set the requested attribute then later
				we can call isRequestedAttribute on the queryResult object and it will use the
				name that was just set.
			--%>
			<c:set target="${queryResults}" property="requestedAttributeName" value="${attribute.name}"/>
			
			<c:choose>
				<c:when test="${!crQueryResults.requestedAttribute}">
					<%-- do nothing when the user did not want this attribute --%>
				</c:when>
				<c:when test="${attribute.isSpanning}">
					<tr>
						<td valign="center">
							<b>
								<c:choose>
									<c:when test="${attribute.label == ''}">
										&nbsp;
									</c:when>
									<c:otherwise>
										<c:out value="${attribute.label}"/>
									</c:otherwise>
								</c:choose>
							</b>
						</td>
						<td colspan="3" valign="center">
							<c:choose>
								<c:when test="${attribute.name == 'problem_number'}">
									<c:set var="mouseOver">
										<c:choose>
											<c:when test="${fn:length(queryResultsItem.modifiableIn) == 0}">
												<change:resource key="searchResultsMouseOverSimple">
													<change:param value="${queryResultsItem.fromDB}"/>
												</change:resource>
											</c:when>
											<c:otherwise>
												<change:resource key="ObjectHyperLinkMouseOver">
													<change:param value="${queryResultsItem.fromDB}"/>
													<change:param>
														<change:attributeInformation attributeName="modifiable_in" requestType="ALIAS"/>
													</change:param>
													<change:param value="${queryResultsItem.modifiableIn}"/>
												</change:resource>
											</c:otherwise>
										</c:choose>
								 	</c:set>
										<change:linkCreator text="${attribute.value}" type="CR_SHOW" database="${user.database}" 
										cvid="${attribute.cvid}" mouseOver="${mouseOver}" />
								</c:when>

								<c:when test="${attribute.name == 'crstatus' && crstatusHyperlink}">
									<%
									 	//No good way to do this with EL or JSTL as far as I could so using a scriptlet.
								 		QueryResultsItem queryResultsItem = (QueryResultsItem) pageContext.getAttribute("queryResultsItem");
								 		QueryResultsAttribute problemNumber = queryResultsItem.getAttribute("problem_number");
					
								 		pageContext.setAttribute("problem_number", problemNumber);
								 	%>								
									<c:set var="mouseOver">
										<change:resource key="java0249"/>
									</c:set>
									<change:linkCreator text="${attribute.value}" type="CR_TRANSITION" cvid="${attribute.cvid}"  database="${user.database}" 
										crid="${problem_number.value}" mouseOver="${mouseOver}"/>
								</c:when>

								<c:otherwise>
									<change:attributeFormat name="${attribute.name}" value="${attribute.value}" 
										dateFormat="REPORT" escape="true"/>
								</c:otherwise>
							</c:choose>
						</td>
					</tr>
				</c:when>
				<c:otherwise>
					<c:if test="${isRowOpen == false}">
						<tr>							
						<c:set var="count" value="0"/>
						<c:set var="isRowOpen" value="true"/>
					</c:if>
						<td width="25%" valign="center">
							<b>
								<c:choose>
									<c:when test="${attribute.label == ''}">
										&nbsp;
									</c:when>
									<c:otherwise>
										<c:out value="${attribute.label}"/>
									</c:otherwise>
								</c:choose>
							</b>
						</td>
						<td width="25%" valign="center">							
							<c:choose>
								<c:when test="${attribute.name == 'problem_number'}">
								 	<c:set var="mouseOver">
										<c:choose>
											<c:when test="${fn:length(queryResultsItem.modifiableIn) == 0}">
												<change:resource key="searchResultsMouseOverSimple">
													<change:param value="${queryResultsItem.fromDB}"/>
												</change:resource>
											</c:when>
											<c:otherwise>
												<change:resource key="ObjectHyperLinkMouseOver">
													<change:param value="${queryResultsItem.fromDB}"/>
													<change:param>
														<change:attributeInformation attributeName="modifiable_in" requestType="ALIAS"/>
													</change:param>
													<change:param value="${queryResultsItem.modifiableIn}"/>
												</change:resource>
											</c:otherwise>
										</c:choose>
								 	</c:set>
								 	<change:linkCreator text="${attribute.value}" type="CR_SHOW" cvid="${attribute.cvid}" database="${user.database}" 
								 		mouseOver="${mouseOver}"/>
	  							</c:when>
	  							
	  							<c:when test="${attribute.name == 'crstatus' && crstatusHyperlink}">
									<%
									 	//No good way to do this with EL or JSTL as far as I could so using a scriptlet.
								 		QueryResultsItem queryResultsItem = (QueryResultsItem) pageContext.getAttribute("queryResultsItem");
								 		QueryResultsAttribute problemNumber = queryResultsItem.getAttribute("problem_number");
					
								 		pageContext.setAttribute("problem_number", problemNumber);
								 	%>
									
								 	<c:set var="mouseOver">
								 		<change:resource key="java0249"/>
								 	</c:set>
							 		<change:linkCreator text="${attribute.value}" type="CR_TRANSITION" cvid="${attribute.cvid}"  database="${user.database}" 
							 			crid="${problem_number.value}" mouseOver="${mouseOver}"/>
	  							</c:when>
								
								<c:otherwise>
									<change:attributeFormat name="${attribute.name}" value="${attribute.value}" 
										dateFormat="REPORT" escape="true"/>
								</c:otherwise>
							</c:choose>
						</td>
						<c:set var="count" value="${count + 1}"/>
						
					<c:if test="${((queryResultsItem.attributes[(status.index + 1)].isSpanning) || (count == 2) || (status.last))}">
						<c:choose>
							<c:when test="${count != 2}">
								<td>&nbsp;</td><td>&nbsp;</td>
							</c:when>
							<c:when test="${count != 2 && status.last}">
								<td>&nbsp;</td><td>&nbsp;</td>
							</c:when>
						</c:choose>
						</tr>
						<c:set var="isRowOpen" value="false"/>
					</c:if>
				</c:otherwise>
			</c:choose>
		</c:forEach>
	</table>
	<c:set var="taskQueryResults" value="${queryResultsItem.relatedResults}" scope="request"/>
	<c:set var="isSubTaskReport" value="true" scope="request"/>
	<jsp:include page="/WEB-INF/wsconfig/templates/pt/reports/task_framework/block_loop_task.jsp"/>
	<br>
</c:forEach>
